classdef Event < handle
properties
  timestamp  % time at which this event is scheduled
        
  % Workaround uses a string function name because Matlab does not 
  % support polymorphism.
  runfunction  % name of a function to call when this event occurs.
  % The run function takes only one parameter, the event itself.
        
  data  % any necessary data for executing the event goes here
end
methods
  function ev = Event(t, runfun, dat)
    ev.timestamp = t;
    ev.runfunction = runfun;
    ev.data = dat;
  end
        
  function execute(ev)
    % Calls a function using the text name. This is an alternative way
    % to achieve polymorphism in Matlab.
    feval(ev.runfunction, ev);
  end
end
end