% This function is called by the event scheduler whenever a passenger
% arrives to the system. It adds the passenger to the appropriate elevator
% waiting area and based on its mu parameter schedules the generation of
% the next passenger.
function arrive(ev)

passenger = ev.data.passenger;
elevator = ev.data.elevator;
mu = ev.data.mu;  % time constant for the exponential arrival rate

elevator.addPassenger(passenger);

global EVENT_QUEUE;

next = spawn(passenger.source, passenger.destination, elevator, exprnd(mu)+EVENT_QUEUE.currentTime, mu);
EVENT_QUEUE.enqueue(next)

end