global EVENT_QUEUE;
EVENT_QUEUE = EventQueue();

% Mean arrival interval matrix
% mu(i,j) = mean interarrival time for going from floor i to floor j
mu = [0 8 8;
      8 0 8;
      8 8 0];

el = Elevator(10, 4, 1);

% Generates initial arrival events. Ensuing arrival events are recursively
% generated when these occur.
for src = 1:3
    for dest = 1:3
        if (src == dest)
            continue
        end
        EVENT_QUEUE.enqueue(spawn(src, dest, el, exprnd(mu(src,dest)), mu(src,dest)));
    end
end

% Runs the simulation until time 10000
EVENT_QUEUE.rununtil(10000);

% Initializes matrices for calculating statistics.
count = zeros(3,3);
waitTime = zeros(3,3);
rideTime = zeros(3,3);

% Averages statistics over all the passengers that have exited the elevator.
for p = el.exited
    src = p.source;
    dest = p.destination;
    count(src,dest) = count(src,dest)+1;
    waitTime(src,dest) = waitTime(src,dest) + p.entered-p.birth;
    rideTime(src,dest) = rideTime(src,dest) + p.exited-p.entered; 
end
waitTime = waitTime ./ count
rideTime = rideTime ./ count